/*
 * Asterisk -- A telephony toolkit for Linux.
 *
 * funcs Application For Asterisk
 *
 * Copyright (C) 2005, Anthony Minessale II
 *
 * Anthony Minessale II <anthmct@yahoo.com>
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License
 */

#include <asterisk/file.h>
#include <asterisk/logger.h>
#include <asterisk/channel.h>
#include <asterisk/pbx.h>
#include <asterisk/module.h>
#include <asterisk/lock.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

static char *tdesc = "Demonstration of Asterisk Custom Functions.";

STANDARD_LOCAL_USER;

LOCAL_USER_DECL;


static char *demo_function_exec(char *cmd, char *data) 
{
	/* if you need to mess with data ast_strdupa it first */
	ast_log(LOG_NOTICE, "Demo function called with data %s\n", data);

	/* return any malloc'ed data here it will be free'd for you.*/
	return strdup("demo");
	
}

static struct ast_custom_function_obj demo_function = {
	.name = "demo",
	.desc = "Demo Function",
	.syntax = "$(demo <data>)",
	.function = demo_function_exec,
};


int unload_module(void)
{
	STANDARD_HANGUP_LOCALUSERS;
	return ast_custom_function_unregister(&demo_function);
}

int load_module(void)
{
	return ast_custom_function_register(&demo_function);
}

char *description(void)
{
	return tdesc;
}

int usecount(void)
{
	int res;
	STANDARD_USECOUNT(res);
	return res;
}

char *key()
{
	return ASTERISK_GPL_KEY;
}

